/*

Copyright (c) 2002-2005, Yauheni Akhotnikau
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

- Redistributions of source code must retain the above copyright notice, this
list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright notice, this
list of conditions and the following disclaimer in the documentation and/or
other materials provided with the distribution.

- The name of the author may not be used to endorse or promote products derived
from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

*/

/*!
	\file oess_1/scheme/h/builtin_names.hpp
	\brief Имена встроенных типов.
*/

#if !defined( _OESS_1__SCHEME__BUILTIN_NAMES_HPP_ )
#define _OESS_1__SCHEME__BUILTIN_NAMES_HPP_

#include <oess_1/scheme/h/declspec.hpp>

#include <string>

namespace oess_1 {

namespace scheme {

/*
	Имена встроенных типов ObjESSty-1
*/

/*!
	\return Имя типа oess_1::char_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_char();

/*!
	\return Имя типа oess_1::schar_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_schar();

/*!
	\return Имя типа oess_1::uchar_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_uchar();

/*!
	\return Имя типа oess_1::short_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_short();

/*!
	\return Имя типа oess_1::ushort_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_ushort();

/*!
	\return Имя типа oess_1::int_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_int();

/*!
	\return Имя типа oess_1::uint_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_uint();

/*!
	\return Имя типа oess_1::single_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_single();

/*!
	\return Имя типа oess_1::double_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_double();

/*!
	\return Имя типа std::string.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_std_string();

/*!
	\return Имя типа oess_1::ent_id_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_ent_id();

/*!
	\return Имя типа oess_1::stdsn::serializable_t.
*/
OESS_1__SCHEME__FUNC(const std::string &)
builtin_stdsn_serializable();

//FIX ME: для удобства работы со всеми именами стандартных
//типов необходимо предоставить средства, аналогичные
//pseudo_base_list_t, pseudo_attr_list_t.

} /* namespace scheme */

} /* namespace oess_1 */

#endif

